scalar Cmu_= 0.09;
const scalar Cmu25 = pow025(Cmu_);
const scalarField& y = turbulence->y()[patchi];

const tmp<scalarField> tmuw = turbulence->mu(patchi);
const scalarField& muw = tmuw();

const tmp<scalarField> talphaw = turbulence->alpha(patchi);
const scalarField& alphaw = talphaw();

const tmp<volScalarField> tk = turbulence->k();
const volScalarField& k = tk();

const scalarField& rhow = turbulence->rho().boundaryField()[patchi];
const scalarField& Tw = T.boundaryField()[patchi];
const scalarField& Cpw = Cp.boundaryField()[patchi];

scalarField& faceHeatFlux = heatFlux.boundaryFieldRef()[patchi];

// Populate boundary values for all faces of this patch
forAll(rhow, facei)
{
    label faceCelli = mesh.boundary()[patchi].faceCells()[facei];
    scalar uTau = Cmu25*Foam::sqrt(k[faceCelli]);
    scalar yPlus = uTau*y[facei]/(muw[facei]/rhow[facei]);
    // Molecular Prandtl number
    scalar Pr = muw[facei]/alphaw[facei];
    scalar beta = Foam::pow(3.85*Foam::pow(Pr,1/3) -1.3,2) + 2.12*Foam::log(Pr);
    scalar Gamma = 0.01*Foam::pow(Pr*yPlus,4)/(1+5*Foam::pow(Pr,3)*yPlus);
    scalar A = rhow[facei]*uTau*Cpw[facei]*(T[faceCelli]-Tw[facei]);
    scalar Tplus = Pr*yPlus*Foam::pow(2.71828,-Gamma) + (2.12*Foam::log(yPlus)+beta)*Foam::pow(2.71828,-1/Gamma);
    faceHeatFlux[facei] = A / Tplus;
}